#include <stdio.h>
#include <ctype.h>
#include "warning.h"
#include "X.h"
#include "window.h"
#include "keyboard.h"

static XIC xic = NULL;

void initklav ()  // Zinicializuje cteni z klavesnice.
{
  XIM xim;
  char *imvalret;
  XIMStyles *xim_styles;
  XIMStyle xim_style = 0;
  int i;

  xim = XOpenIM (display, NULL, NULL, NULL);
  if (xim == NULL) {
    warning("openning of input method failed");
  }
  else{
    imvalret = XGetIMValues (xim, XNQueryInputStyle, &xim_styles, NULL);
    if (imvalret != NULL || xim_styles == NULL) {
      warning("input method doesn't support any styles");
    }

    if (xim_styles) {
      xim_style = 0;
      for (i = 0;  i < xim_styles->count_styles;  i++) {
	if (xim_styles->supported_styles[i] ==
	    (XIMPreeditNothing | XIMStatusNothing)) {
	  xim_style = xim_styles->supported_styles[i];
	  break;
	}
      }
      
      if (xim_style == 0) {
	warning("input method doesn't support the style we support");
      }
      XFree (xim_styles);
    }
  }
  if (xim && xim_style) {
    xic = XCreateIC (xim, 
		     XNInputStyle, xim_style, 
		     XNClientWindow, textwin, 
		     XNFocusWindow, textwin,
		     NULL);

    if (xic == NULL) {
      warning("Creating of XIC failed");
    }
  }
}

char xkeyznak (XEvent *e)
{
  int pocetznaku;
  char str[8];
  XKeyEvent *event = &(e->xkey);

  if(xic){
    if(XFilterEvent (e, textwin)) return 0;
    pocetznaku = XmbLookupString(xic, event, str, 8, NULL, NULL);
  }
  else pocetznaku = XLookupString (event, str, 8, NULL, NULL);
     // Nahradni varianta, kdyz se nenacte xic (zcela nefunguje)

  // Zkontroluji, zda jde skutecne o znak:
  if(pocetznaku != 1) return 0;
  if(isprint(str[0])) return str[0];
  return 0;
}
