#include<string.h>
#include<stdlib.h>
#include "defaults.h"
#include "types.h"
#include "pin.h"
#include "warning.h"
#include "X.h"
#include "window.h"
#include "pixmap.h"
#include "map.h"
#include "post.h"
#include "pol.h"
#include "input.h"
#include "popup.h"
#include "output.h"
#include "bindings.h"
#include "predmet.h"

kq_predmet *inventar = NULL;
kq_predmet *prvpredmet = NULL;
kq_color *dosahpredmet = NULL;

static void zobrazpredmet (kq_predmet *p)
{
  if(p->post) warning("zobrazovany predmet uz je zobrazeny");

  if(p->slovo) p->slovo->kontext++;
  p->post = vytvorpost(0,0,0,0,0,1,0);
  p->post->barvy = 0;
  p->post->zdi = 0;
  zmenanip(p->post, nactianip(-p->pix_x, -p->pix_y, p->nazev,1,0,1,0,1));
  p->post->z = p->pix_z;
  post_submap(p->post, p->nazev, -p->sm_x, -p->sm_y, p->sm_z);
}

void zobrazpredmety ()
{
  kq_predmet *pom;

  for(pom = aktupol->predmety; pom; pom = pom->polnext)
    zobrazpredmet(pom);
}

static void zmizpredmet (kq_predmet *p)
{
  if(p->slovo) p->slovo->kontext--;
  if(p->post) znicpost(p->post);
  else warning("predmet pro zmizeni neni zobrazeny");
  p->post = NULL;
}

void zmizpredmety ()
{
  kq_predmet *pom;

  for(pom = aktupol->predmety; pom; pom = pom->polnext){
    pom->post = NULL;
    if(pom->slovo) pom->slovo->kontext--;
  }
}

static void zaradpredmet (kq_predmet *p)
{
  kq_predmet **kam;

  if(p->inv){
    kam = &inventar;
    if(p->slovo) p->slovo->kontext++;
  }
  else{
    if(!p->pol) return;
    kam = &p->pol->predmety;
    if(win && p->pol == aktupol) zobrazpredmet(p);
  }

  p->polnext = *kam;
  *kam = p;
}

static void vyradpredmet (kq_predmet *p)
{
  kq_predmet **odkud;

  if(p->inv){
    odkud = &inventar;
    if(p->slovo) p->slovo->kontext--;
  }
  else{
    if(!p->pol) return;
    odkud = &p->pol->predmety;
    if(win && p->pol == aktupol) zmizpredmet(p);
  }

  while(*odkud && *odkud != p) odkud = &(*odkud)->polnext;
  if(!*odkud){
    warning("nepodarilo se vyradit predmet");
    return;
  }
  *odkud = p->polnext;
  return;
}

kq_predmet *vytvorpredmet (char *nazev, char slovo)
{
  kq_predmet *vysledek;

  vysledek = (kq_predmet *)malloc(sizeof(kq_predmet));

  vysledek->inv = 0;
  vysledek->stav = 0;
  vysledek->pol = NULL;
  vysledek->nazev = strdup(nazev);
  if(slovo){
    vysledek->slovo = add_word(0);
    vysledek->slovo->informace = pinpointer(vysledek);
    vysledek->slovo->typ = OBJWORD;
  }
  vysledek->post = NULL;
  vysledek->next = prvpredmet;
  prvpredmet = vysledek;

  return vysledek;
}

void predmetinv (kq_predmet *p)
{
  vyradpredmet(p);
  p->inv = 1;
  zaradpredmet(p);
}

void predmetnull (kq_predmet *p)
{
  if(!p->inv && !p->pol) return;
  vyradpredmet(p);
  p->inv = 0;
  p->pol = NULL;
}

void predmetpol (kq_predmet *p, kq_policko *pol,
		 int pix_x, int pix_y, float pix_z,
		 int sm_x, int sm_y, float sm_z)
{
  if(!pol) warning("predmetpol: pol == NULL");

  vyradpredmet(p);
  p->inv = 0;
  p->pol = pol;
  p->pix_x = pix_x;
  p->pix_y = pix_y;
  p->pix_z = pix_z;
  p->sm_x = sm_x;
  p->sm_y = sm_y;
  p->sm_z = sm_z;
  zaradpredmet(p);
}

void zmenprnazev (kq_predmet *p, char *nazev)
{
  free(p->nazev);
  p->nazev = strdup(nazev);
  p->stav = !p->stav;
}

void uzmaspredmet (kq_predmet *p)
{
  popupwarning("_uz mas", p->slovo->nazev);
}

void sebralspredmet (kq_predmet *p)
{
  popupoutput("_bere", p->slovo, DEF_POP_SIRKA, DEF_POP_VYSKA, DEF_POP_X, DEF_POP_Y);
}

char seberpredmet (kq_predmet *p, int x, int y)
{
  if(p->inv){
    uzmaspredmet(p);
    return 0;
  }
  if(!p->post) return -1;
  if(dosahpredmet &&
     (!p->post->submap ||
      smpixel(p->post->submap, x, y) != dosahpredmet)){
    popup_info("_too far");
    return 0;
  }

  predmetinv(p);
  sebralspredmet(p);

  return 1;
}

char seberslovo (kq_word *slovo)
{
  if(!slovo || !ovlpost || slovo->typ != OBJWORD
     || slovo->informace.typ != PINPOINTER){
    warning("seberslovo selhalo");
    return 0;
  }

  return seberpredmet((kq_predmet *)(slovo->informace.u.p), ovlpost->x, ovlpost->y);
}

void koukniinv (kq_predmet *p)
{
  kq_pixmap *pix;
  Window w;
  int x, y, sirka, vyska;
  char *label;

  pix = nactikqXPM(p->nazev, 0);
  sirka = pix->PIX_SIR*ratio;
  vyska = pix->PIX_VYS*ratio;
  x = (win_sirka-sirka)/2;
  y = (win_vyska*UINVPOMER-vyska)/2;
  w = XCreateSimpleWindow(display, win, x, y, sirka, vyska, 0,
			  BlackPixel(display,screen),
			  WhitePixel(display,screen));
  XShapeCombineMask (display, w, ShapeBounding,
		     0, 0, pix->akanal, ShapeSet);
  XSetWindowBackgroundPixmap(display, w, pix->barvy);
  XMapWindow(display, w);

  if(p->stav) label = "__inv_look";
  else label = "_inv_look";
  popupoutput(label, p->slovo, UINVSIRKA, 1-UINVPOMER, 0.5, 1);

  XDestroyWindow(display, w);
  freekqPixmap(pix);
}


void ukazinv ()
{
  int i, j, pos;
  kq_predmet *pom;
  char **vyber;
  char *label;

  if(!inventar){
    popupoutput("_empty inv", NULL, DEF_POP_SIRKA, DEF_POP_VYSKA,
		DEF_POP_X, DEF_POP_Y);
    return;
  }

  i = 1;
  for(pom = inventar; pom; pom = pom->polnext) i++;
  vyber = malloc(sizeof(char *) * i);
  i = 0;
  for(pom = inventar; pom; pom = pom->polnext){
    if(pom->stav) label = "__inv";
    else label = "_inv";
    vyber[i] = outputstring(label, pom->slovo);
    if(!vyber[i]) vyber[i] = pom->nazev;
    i++;
  }
  vyber[i] = NULL;

  i = 0; pos = 0;
  for(;;){
    i = popupselect(DEF_POP_SIRKA, DEF_POP_VYSKA, DEF_POP_X, DEF_POP_Y,
		    outputstring("_inventar", NULL), vyber, i, &pos);
    if(i < 0) break;
    pom = inventar;
    for(j = 0; j<i; j++) pom = pom->polnext;
    koukniinv(pom);
  }
  free(vyber);
}

void deleteApredmets ()
{
  kq_predmet *pom, *pomo;

  for(pom = prvpredmet; pom; pom = pomo){
    pomo = pom->next;
    if(!pom->inv && pom->pol) pom->pol->predmety = NULL;
    free(pom->nazev);
    free(pom);
  }
  prvpredmet = NULL;
  inventar = NULL;
}
